import java.io.BufferedReader;
import java.io.IOException;

import org.antlr.v4.runtime.CharStream;
import org.antlr.v4.runtime.CharStreams;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.tree.ParseTree;
import org.antlr.v4.runtime.*;
import java.io.*;
import java.nio.file.Files;
import java.lang.*;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;

import OntoDLPlus.*;

public class OntoDLPlus {

    public OntoDLPlus(String[] args) {
        if(args.length>=1) {
            int i=0;
            while(i<args.length) {
                String filename = args[i];
                String finalfile = ".swap_"+filename;
                CharStream input;
                try {
                    //generate new file without imports
                    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(filename), "UTF-8"));
                    StringBuilder fileString= new StringBuilder();
                    String line;
                    while ((line=br.readLine()) != null) {
                        if(line.matches("[ \t]*expand +[a-zA-Z0-9_./]+ *;")) {
                            line=line.replaceFirst("expand","");
                            line=line.replaceAll(";","");
                            line=line.replaceAll(" ","");
                            line=Files.readString(Paths.get(System.getProperty("user.dir"),"/",line));
                            fileString.append(line);
                        } else {
                            fileString.append(line);
                            fileString.append(System.lineSeparator());
                        }
                    }
                    if (!Files.exists(Paths.get(finalfile))) {
                        Files.createFile(Paths.get(finalfile));
                    } else {
                        Files.delete(Paths.get(finalfile));
                        Files.createFile(Paths.get(finalfile));
                    }
                    BufferedWriter outwriter = Files.newBufferedWriter(Paths.get(finalfile), StandardCharsets.UTF_8);
                    outwriter.append(fileString.toString());
                    outwriter.flush();
                    //parse generated file
                    input = CharStreams.fromFileName(finalfile);
                    OntoDLPlusLexer lexer = new OntoDLPlusLexer(input);
                    CommonTokenStream tokens = new CommonTokenStream(lexer);
                    OntoDLPlusParser parser = new OntoDLPlusParser(tokens);
                    OntoDLPlusParser.OntologyContext parsed = parser.ontology();
                    Ontology res= parsed.onto;
                    //delete generad file
                    File deleted= new File(finalfile);
                    deleted.delete();
                } catch (IOException e1) {
                    System.err.println(e1.getMessage());
                    return;
                }
                i++;
            }
        } else {
            /*int i=0;
            for(i=0; i< args.length; i++) {
                System.out.println(args[i]);
            }
            System.out.println(args.length);*/
            System.out.println("ERROR: Please specify ontology file(s).");
        }
    }

    public static void main(String[] args) {
        new OntoDLPlus(args);
    }
}
