package OntoDLPlus;

import java.util.HashSet;
import java.util.Set;

public class Relation {
    private String name;
    private String domain;
    private String codomain;
    private Set<String> props;

    public Relation (String n) {this.name=n; this.props= new HashSet<String>(); this.codomain=null; this.domain=null;}

    public Relation (String n, String d, String c, Set<String> p) {
        this.name=n;
        this.domain=d;
        this.codomain=c;
        if(p!=null)
            this.props=p;
        else
            this.props= new HashSet<String>();
    }

    public void setDomain(String d) {this.domain=d;}
    public void setCodomain(String c) {this.codomain=c;}
    public void addProps (Set<String> r) {
        for(String s: r) {
            this.props.add(s);
        }
    }

    public String getName() {
        return this.name;
    }

    public String getCodomain() {
        return codomain;
    }

    public String getDomain() {
        return domain;
    }

    public Set<String> getProps() {
        return props;
    }

    public boolean isInverse () {
        if(this.props!=null) {
            for(String s: props) {
                if (s.startsWith("inversa=")) return true;
            }
        }
        return false;
    }

    public String getInverse() {
        String res=new String();
        if(this.props!=null) {
            for(String s: props) {
                if (s.startsWith("inversa=")) {
                    return s.replaceFirst("inversa=","");
                }
            }
        }
        return res;
    }

    public void addInverse(String s) {
        this.props.add("inversa="+s);
    }

    public boolean isInjective () {
        if(this.props!=null) {return props.contains("injectiva");}
        else return false;
    }

    public boolean isSurjective () {
        if(this.props!=null) {return props.contains("sobrejectiva");}
        else return false;
    }

    public boolean isEntire () {
        if(this.props!=null) {return props.contains("inteira");}
        else return false;
    }

    public boolean isSimple() {
        if(this.props!=null) {return props.contains("simples");}
        else return false;
    }
}
